
import chimera.extension

# -----------------------------------------------------------------------------
#
class Segger_EMO ( chimera.extension.EMO ):

  def name(self):
    return 'Segger'
  def description(self):
    return self.categoryDescriptions()['Volume Data']
  def categories(self):
    return self.categoryDescriptions().keys()
  def categoryDescriptions(self):
    # since we want to use specialized descriptions for certain categories...
    return {
      'Volume Data': 'Segment volume data to identify components',
    }
  def icon(self):
    return self.path('volseg.png')
  def activate(self):
    # self.module('volumedialog').show_volume_dialog()
    d = self.module('segment_dialog').show_volume_segmentation_dialog()
    return None

# -----------------------------------------------------------------------------
# Register volume dialog and menu entry.
#

emo = Segger_EMO ( __file__ )
chimera.extension.manager.registerExtension ( emo )





