



#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>

#ifdef WIN32
#include <io.h>
#endif

#include <stdio.h>
#include <stdlib.h>
#include <string.h>


#include "DensityMap.h"
#include "SegRegions.h"

#include <iostream>
#include <string>
using namespace std;


// soulja boy getting money swag on twenty up up yeeea


int Region::Overlap ( Region &r )
{
	int ov = 0;
	if ( (r.COM - COM).Length() > r.dBoundRad + dBoundRad + 1.0 ) {
		return 0;
	}
	for (unsigned int i=0; i < vi.size(); i++) {
		float *x = vi[i];
		int xi = (int) x[0];
		int xj = (int) x[1];
		int xk = (int) x[2];
		
		for (unsigned int ri=0; ri < r.vi.size(); ri++)
		{
			float *y = vi[i];
			int yi = (int) y[0];
			int yj = (int) y[1];
			int yk = (int) y[2];
			
			if ( xi == yi && xj == yj && xk == yk ) {
				ov++;
			}
		}
	}
	return ov;
}


int Region::OverlapF ( Region &r )
{
	int ov = 0;
	if ( (r.COM - COM).Length() > r.dBoundRad + dBoundRad + 1.0 ) {
		return 0;
	}
	for (unsigned int vii=0; vii < r.vi.size(); vii++)
	{
		float *ijk = r.vi[vii];
		int i = (int) ijk[0];
		int j = (int) ijk[1];
		int k = (int) ijk[2];
		
		map < int, map< int, map< int, int> > >::iterator kit = mi.find ( i );
		if ( kit != mi.end() )
		{
			map< int, map< int, int> > &ji = kit->second;
			map< int, map< int, int> >::iterator jit = ji.find ( j );
			if ( jit != ji.end() )
			{
				map< int, int > &ii = jit->second;
				map< int, int >::iterator it = ii.find ( k );
				if ( it != ii.end() )
				{
					ov++;
				}
			}
		}
	}
	
	return ov;
}


void Region::MakeVerticesMap ()
{
	for ( unsigned int i=0; i < vi.size(); i++ ) {
		float *ijk = vi[i];
		int ii = (int) ijk[0];
		int jj = (int) ijk[1];
		int kk = (int) ijk[2];
		mi[ii][jj][kk] = 1;
	}
}


void Region::COM_and_bRad ()
{
	COM = Vector3f (0,0,0);
	
	for ( unsigned int i=0; i < vi.size(); i++ ) {
		COM += vi[i];
	}
	
	COM /= (float) vi.size();
	
	dBoundRad = 0.0;
	for (unsigned int ii=0; ii < vi.size(); ii++)
	{
		float l = ( vi[ii] - COM).Length();
		if ( l > dBoundRad ) {
			dBoundRad = l;
		}
	}
}



void Regions::Clear ()
{
	
	mRegs.clear();
	
	for ( map < int, map < int, RegsConnection* > >::iterator it = mCons.begin(); it != mCons.end(); it++ ) {
		int r1 = it->first;
		map < int, RegsConnection* > &r1_cons = it->second;
		for ( map < int, RegsConnection* >::iterator it2 = r1_cons.begin(); it2 != r1_cons.end(); it2++ ) {
			int r2 = it2->first;
			if ( r2 > r1 )
				delete it2->second;
		}
		r1_cons.clear();
	}
	mCons.clear();
}





void Regions::Write ( const char *fname )
{
	name = fname;
	//name = name.substr( name.rfind("/")+1 );
	
	printf ( "Writing %s\n", fname );
	FILE *fp = fopen ( fname, "wb" );
	
	printf ( " - writing %d regions\n", mRegs.size() );
	float nregions = (float) mRegs.size();
	fwrite ( &nregions, sizeof(float), 1, fp );
	
	for ( map <int, Region>::iterator it = mRegs.begin(); it != mRegs.end(); it++ )
	{
		//int ri = it->first;
		Region &r = it->second;
		
		float num = (float) r.vi.size();
		// printf ("%d - %d\n", ri, num);
		fwrite ( &num, sizeof(float), 1, fp );
		
		fwrite ( &(r.vi[0][0]), sizeof(float), 3*r.vi.size(), fp );

		// number of parents
		num = 0.0f;
		fwrite ( &num, sizeof(float), 1, fp );

		/*
		 for ( int i=0; i < r.vi.size(); i++ ) {
		 Vector3<int> &ind = r.vi[i];
		 //printf (" %d,%d,%d", ind[0], ind[1], ind[2]);
		 find[0] = (float) ind[0]; find[1] = (float) ind[1]; find[2] = (float) ind[2];
		 write ( fd, find, 3*sizeof(float) );
		 }
		 */
		// printf ("\n");
	}
	
	
	float ncon = 0.0;
	for ( map < int, map < int, RegsConnection* > >::iterator it = mCons.begin(); it != mCons.end(); it++ ) {
		map < int, RegsConnection* > &r1_cons = it->second;
		for ( map < int, RegsConnection* >::iterator it2 = r1_cons.begin(); it2 != r1_cons.end(); it2++ ) {
			if ( it->first < it2->first ) {
				ncon += 1.0;
			}
		}
	}
	
	printf ( "- writing %.0f connections\n", ncon );
	fwrite ( &ncon, sizeof(float), 1, fp );
	
	float a[4];
	for ( map < int, map < int, RegsConnection* > >::iterator it = mCons.begin(); it != mCons.end(); it++ ) {
		map < int, RegsConnection* > &r1_cons = it->second;
		for ( map < int, RegsConnection* >::iterator it2 = r1_cons.begin(); it2 != r1_cons.end(); it2++ ) {
			if ( it->first < it2->first ) {
				a[0] = (float) it->first;
				a[1] = (float) it2->first;
				RegsConnection *rc = it2->second;
				a[2] = (float) rc->N;
				a[3] = (float) rc->totD;
				//printf ( "%d %d - %.0f, %f\n", ri1, ri2, a[2], a[3] );
				fwrite( a, sizeof(float), 4, fp);
			}
		}
	}
	
	fclose ( fp );
}


void Regions::Read ( const char *fname )
{
	Clear();
	
	name = fname;
	//name = name.substr( name.rfind("/")+1 );
	
	int fd;
	if ( (fd = open(fname, O_RDONLY)) == -1)
	{
		printf("- error opening %s\n", fname);
		return;
	}
	
	float nregions;
	read ( fd, &nregions, sizeof(float) );
	printf ("%s - %.0f regions\n", name.c_str(), nregions );
	
	for ( int i=0; i < (int) nregions; i++ )
	{
		float nvoxs;
		read ( fd, &nvoxs, sizeof(float) );
		
		Region &r = mRegs[i+1];
		r.vi.resize ( (int) nvoxs );
		
		read ( fd, &(r.vi[0][0]), 3*(int)nvoxs*sizeof(float) );
		
		//for (int vi=0; vi < nvoxs; vi++) {
		//	printf ( " %d - %f %f %f\n", i, r.vi[vi][0], r.vi[vi][1], r.vi[vi][2] );
		//}
		
		r.COM_and_bRad();
		//r.MakeVerticesMap();
	}
	
	printf ( " - read %d regions\n", mRegs.size() );
	
	float ncons; read ( fd, &ncons, sizeof(float) );
	printf (" - reading %.0f connections\n", ncons );
	
	float a[4];
	for ( int j=0; j < (int) ncons; j++ )
	{
		read ( fd, a, 4*sizeof(float) );
		int r1 = (int) a[0];
		int r2 = (int) a[1];
		
		RegsConnection *rc = new RegsConnection ( /*r1, r2*/ );
		rc->N = (double) a[2];
		rc->totD = (double) a[3];
		mCons[r1][r2] = rc;
		mCons[r2][r1] = rc;
	}
	
	close ( fd );
}


void Regions::Compute_COMs_bRads ()
{
	printf ( "Getting coms and brads for %s\n", name.c_str() );
	for ( map< int, Region >::iterator ri = mRegs.begin(); ri != mRegs.end(); ri++ )
	{
		Region &r = ri->second;
		r.COM_and_bRad();
	}
}




Regions* Regions::GroupByOverlap ( Regions &sregs )
{
	map < int, vector< int > > ri_group;
	
	printf ( "Computing %d to %d region overlaps\n", mRegs.size(), sregs.mRegs.size() );
	
	for ( map< int, Region >::iterator ri = mRegs.begin(); ri != mRegs.end(); ri++ )
	{
		int rid = ri->first;
		Region &r = ri->second;
		
		//printf ( "region %d - %d voxels", rid, r.vi.size() );
		
		int max_overlap = 0;
		int max_ov_sri = -1;
		
		r.MakeVerticesMap();
		
		for ( map<int,Region>::iterator sri = sregs.mRegs.begin(); sri != sregs.mRegs.end(); sri++ )
		{
			int srid = sri->first;
			Region &sr = sri->second;
			
			int overlap = r.OverlapF ( sr );
			
			// printf ( "  -- region %d - %d voxels - overlap %d\n", lid, lr.vi.size(), overlap );
			
			if ( overlap > max_overlap ) {
				max_overlap = overlap;
				max_ov_sri = srid;
			}
		}
		
		if ( max_overlap > 0 ) {
			//printf ( " -- max overlap with %d (%d)", max_ov_sri, max_overlap );
			ri_group [ max_ov_sri ].push_back ( rid );
		}
		
		//printf ( "\n" );
	}
	
	
	Regions *nregs = new Regions();
	int nrid_at = 0;
	map<int,int> rid_2_nrid;
	
	for ( map < int, vector< int > >::iterator gi = ri_group.begin(); gi != ri_group.end(); gi++ )
	{
		vector< int > &rids = gi->second;
		
		nrid_at++;
		Region &new_reg = nregs->mRegs[nrid_at];
		
		Region &to_sharpen_reg = sregs.mRegs [ gi->first ];
		new_reg.p_reg = &to_sharpen_reg;
		
		// printf ( "- region %d - %d regions - new index %d\n", gi->first, rids.size(), nrid_at );
		
		for ( vector< int >::iterator ri=rids.begin(); ri != rids.end(); ri++ )
		{
			Region &reg = mRegs[ *ri ];
			// for ( unsigned int vvi=0; vvi < reg.vi.size(); vvi++ ) {
			for ( vector< Vector3f >::iterator inds = reg.vi.begin(); inds != reg.vi.end(); inds++ )
			{
				new_reg.vi.push_back ( *inds );
			}
			rid_2_nrid[ *ri ] = nrid_at;
			
			new_reg.sub_regs.push_back ( &reg );
		}
		
		//printf ("%d[%d] ", nrid_at, new_reg.sub_regs.size());
	}
	//printf ("\n");
	
	
	// build connections for new regions
	
	printf ( "Transferring connections\n" );
	for ( map < int, map < int, RegsConnection* > >::iterator it = mCons.begin(); it != mCons.end(); it++ )
	{
		map < int, RegsConnection* > &r1_cons = it->second;
		for ( map < int, RegsConnection* >::iterator it2 = r1_cons.begin(); it2 != r1_cons.end(); it2++ )
		{
			RegsConnection *rc = it2->second;
			
			int nri1 = rid_2_nrid [ it->first ];
			int nri2 = rid_2_nrid [ it2->first ];
			
			if ( nri1 == nri2 ) continue;
			
			if ( nri1 == 0 || nri2 == 0 ) continue;
			
			RegsConnection *nrc = nregs->mCons[nri1][nri2];
			if ( nrc == NULL ) {
				nrc = new RegsConnection ( /*nri1, nri2*/ );
				nregs->mCons[nri1][nri2] = nrc;
				nregs->mCons[nri2][nri1] = nrc;
			}
			nrc->totD += rc->totD;
			nrc->N += rc->N;
		}
	}
	
	return nregs;
}


void Regions::MakeNodes ( int rfile )
{
	for ( map <int, Region>::iterator it = mRegs.begin(); it != mRegs.end(); it++ )
	{
		int ri = it->first;
		Region &r = it->second;
		
		r.node = new RegionNode();
		r.node->rfile = rfile;
		r.node->rid = ri;
	}
}


void Regions::AssignCNodesToSubRegs ()
{
	printf ( "\nMaking nodes for sub regs in %s\n", name.c_str() );
	
	for ( map< int, Region >::iterator sri = mRegs.begin(); sri != mRegs.end(); sri++ )
	{
		int srid = sri->first;
		Region &sreg = sri->second;
		
		sreg.node = sreg.p_reg->node;
		sreg.node->rid = srid;
		
		// printf ("Region %d : %d sub regions\n", sri->first, sreg.sub_regs.size() );
		
		for ( unsigned int sub_sri = 0; sub_sri < sreg.sub_regs.size(); sub_sri++ )
		{
			Region *reg = sreg.sub_regs[sub_sri];
			sreg.node->cnodes.push_back ( reg->node );
		}
	}
}


void Regions::AssignNodesByOverlap ( Regions &prev_regs, Regions &sharpened_regs )
{
	printf ( "Assigning region nodes  %s\n", name.c_str() );
	printf ( " - prev regions         %s\n", prev_regs.name.c_str() );
	printf ( " - sharpened regs       %s\n", sharpened_regs.name.c_str() );
	printf ( "\n" );
	
	
	for ( map< int, Region >::iterator sri = sharpened_regs.mRegs.begin(); sri != sharpened_regs.mRegs.end(); sri++ )
	{
		int sharpened_rid = sri->first;
		Region &sharpened_reg = sri->second;
		Region *to_sharpen_reg = sharpened_reg.p_reg;
		
		sharpened_reg.node = to_sharpen_reg->node;
		sharpened_reg.node->rid = sharpened_rid;
		
		if ( 0 ) printf ( "sharpened region %d [%d] (%d subregs) - from xxx [%d] (%d subregs)\n", 
						 sharpened_rid, sharpened_reg.vi.size(), sharpened_reg.sub_regs.size(),
						 to_sharpen_reg->vi.size(), to_sharpen_reg->sub_regs.size() );
		
		for ( unsigned int sub_ri = 0; sub_ri < sharpened_reg.sub_regs.size(); sub_ri++ )
		{
			Region *reg = sharpened_reg.sub_regs[sub_ri];
			
			int max_overlap = 0;
			Region *max_overlap_sreg = NULL;
			
			for ( unsigned int sub_sri = 0; sub_sri < to_sharpen_reg->sub_regs.size(); sub_sri++ )
			{
				Region *sreg = to_sharpen_reg->sub_regs[sub_sri];
				
				int overlap = reg->OverlapF ( *sreg );
				// printf ( "  -- region %d - %d voxels - overlap %d\n", lid, lr.vi.size(), overlap );
				
				if ( overlap > max_overlap ) {
					max_overlap = overlap;
					max_overlap_sreg = sreg;
				}
			}
			
			if ( max_overlap_sreg != NULL ) {
				max_overlap_sreg->node->cnodes.push_back ( reg->node );
			}
			else {
				printf ( " - sub region doesn't overlap any smoother sub-regions!\n" );
			}
		}
		//printf ( "\n" );
	}
}



void RegionNode::WriteToFile ( FILE *fp )
{
	fprintf ( fp, "%d %d\n", rfile, rid );
	if ( cnodes.size() > 0 )
	{
		fprintf ( fp, "{\n" );
		for ( vector<RegionNode*>::iterator it = cnodes.begin(); it != cnodes.end(); it++ )
		{
			RegionNode *rn = *it;
			rn->WriteToFile ( fp );
		}
		fprintf ( fp, "}\n" );
	}
}



